Summary: An authoritative DNS daemon
Name: knot
Version: 1.1.0
Release: 1%{?dist}
License: GPLv3+
Group: System Environment/Daemons
URL: http://www.knot-dns.cz
Source0: http://public.nic.cz/files/knot-dns/%{name}-%{version}.tar.gz
Source1: %{name}.service
Source2: %{name}.conf
Source3: %{name}.sysconfig

BuildRequires: flex userspace-rcu-devel openssl-devel
BuildRequires: bison systemd-units libcap-ng-devel

Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units

# people should not punt man page readers to info pages :(
Requires(post): info
Requires(preun): info

%description
KNOT DNS is a high-performance authoritative DNS server implementation.

%prep
%setup -q

%build
CFLAGS="%{optflags} -lgcc_eh" CXXFLAGS="%{optflags} -lgcc_eh" \
./configure --prefix=%{_prefix} \
	--sysconfdir=%{_sysconfdir}/%{name} \
	--localstatedir=%{_sharedstatedir} \
	--libdir=%{_libdir} --libexecdir=%{_libexecdir}/%{name}
make %{?_smp_mflags}


%install
make install DESTDIR=%{buildroot}
install -d %{buildroot}/%{_sharedstatedir}/%{name}
install -d %{buildroot}/%{_unitdir} %{buildroot}/%{_sysconfdir}/sysconfig
install -p -m644 %{SOURCE1} %{buildroot}/%{_unitdir}/%{name}.service
install -p -m644 %{SOURCE2} %{buildroot}/%{_sysconfdir}/%{name}/%{name}.conf
install -p -m644 %{SOURCE3} %{buildroot}/%{_sysconfdir}/sysconfig/%{name}

rm %{buildroot}/%{_infodir}/dir

%pre
getent group knot >/dev/null || groupadd -r knot
getent passwd knot >/dev/null || \
useradd -r -g knot -d %{_sysconfdir}/knot -s /sbin/nologin \
-c "Knot DNS resolver" knot
exit 0

%post
if [ $1 -eq 1 ]; then
	# Initial installation
	/bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi
/sbin/install-info %{_infodir}/%{name}.info %{_infodir}/dir || :

%preun
if [ $1 -eq 0 ] ; then
	# run before a package is removed
	/bin/systemctl --no-reload disable %{name}.service > /dev/null 2>&1 || :
	/bin/systemctl stop %{name}.service > /dev/null 2>&1 || :
fi
if [ $1 = 0 ] ; then
  /sbin/install-info --delete %{_infodir}/%{name}.info %{_infodir}/dir || :
fi

%postun
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
	# run after a package is removed
	/bin/systemctl try-restart %{name}.service >/dev/null 2>&1 || :
fi

%files
%dir %attr(750,root,root) %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%exclude %{_sysconfdir}/%{name}/example.com.zone
%exclude %{_sysconfdir}/%{name}/knot.sample.conf
%{_sbindir}/*
%{_libexecdir}/%{name}
%exclude %{_libexecdir}/%{name}/unittests*
%{_mandir}/man8/%{name}*.8*
%{_unitdir}/%{name}.service
%dir %{_sharedstatedir}/%{name}
%doc COPYING AUTHORS RELNOTES KNOWN_ISSUES README
%doc samples/bogus25.com.zone samples/example.com.zone.signed samples/knot.full.conf
%doc samples/example.com.zone samples/example.com.zone.signed.nsec3 samples/knot.min.conf
%doc %{_infodir}/*gz

%changelog
* Sat Oct 27 2012 Paul Wouters <pwouters@redhat.com> - 1.1.0-1
- Updated to 1.1.0
- Add info page requirements
- Add /etc/sysconfig/knot, which is already supported in systemd script

* Fri May 15 2012 Stanislav Petr <glux@glux.org> - 1.0.6-2
- Try to fix compilation problem on some systems - force add -lgcc_eh to gcc flags

* Wed May 13 2012 Stanislav Petr <glux@glux.org> - 1.0.6-1
- Update to versio 1.0.6
- Change attrs to 750 on /etc/knot - only for root (knot configuration can contain DNS keys for zone updates)
- Clean content in /etc/knot

* Thu May 1 2012 Stanislav Petr <glux@glux.org> - 1.0.5-1
- Update to version 1.0.5

* Wed Apr 18 2012 Stanislav Petr <glux@glux.org> - 1.0.3-1
- Fixed knot directory ownership.
- Update to version 1.0.3
- Merged changes from Paul Wouters <pwouters@redhat.com> 
- Removed unnecessary commands pro %%post script
- Add knot user
- More configuration samples in /usr/share/doc/knot

* Thu Mar 1 2012 Stanislav Petr <glux@glux.org> - 1.0.0-4
- Update to upstream version 1.0.0
- Fix %%{_sharedstatedir} usage in .spec.
- Fix file and directories ownership
- Fix service upgrade in postun in rpm.
- Do not install unittests.

* Wed Jan 25 2012 Stanislav Petr <glux@glux.org> - 0.9.1-3
- Update to upstream version 0.9.1

* Mon Dec 12 2011 Stanislav Petr <glux@glux.org> - 0.8.1-3
- Add docs (COPYING AUTHORS RELNOTES KNOWN_ISSUES)
- Update rpm building options.
  Use %%{_sharedstatedir} instead of %%{_var}/lib,
  dafault value for %%{buildroot} path
- Remove ldconfig from post and postun in rpm.
- Update licence to GPLv3+

* Wed Dec 07 2011 Stanislav Petr <glux@glux.org> - 0.8.1-2
- RPM build fix

* Mon Dec 05 2011 Stanislav Petr <glux@glux.org> - 0.8.1-1
- Create
